; HP-PA 7100/7200 __mpn_addmul_1 -- Multiply a limb vector with a limb and
; add the result to a second limb vector.

; Copyright (C) 1995 Free Software Foundation, Inc.

; This file is part of the GNU MP Library.

; The GNU MP Library is free software; you can redistribute it and/or modify
; it under the terms of the GNU Library General Public License as published by
; the Free Software Foundation; either version 2 of the License, or (at your
; option) any later version.

; The GNU MP Library is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
; or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
; License for more details.

; You should have received a copy of the GNU Library General Public License
; along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
; the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
; MA 02111-1307, USA.

; INPUT PARAMETERS



	.code
	.export		__mpn_addmul_1
__mpn_addmul_1
	.proc
	.callinfo	frame=128,no_calls
	.entry

	ldo	128(%r30),%r30
	stws	%r23,-16(%r30)
	add	 %r0,%r0,%r28			; clear cy and %r28
	addib,<	-4,%r24,L$few_limbs
	fldws	-16(%r30),%fr31R

	ldo	-112(%r30),%r31
	stw	%r3,-96(%r30)
	stw	%r4,-92(%r30)
	stw	%r5,-88(%r30)
	stw	%r6,-84(%r30)
	stw	%r7,-80(%r30)

	bb,>=,n	 %r25,29,L$0

	fldws,ma 4(%r25),%fr4
	ldws	 0(%r26),%r19
	xmpyu	 %fr4,%fr31R,%fr5
	fstds	 %fr5,-16(%r31)
	ldws	-16(%r31),%r28
	ldws	-12(%r31),%r21
	add	 %r19,%r21,%r19
	addib,< -1,%r24,L$few_limbs
	stws,ma	 %r19,4(%r26)

; start software pipeline ----------------------------------------------------
L$0	fldds,ma 8(%r25),%fr4
	fldds,ma 8(%r25),%fr8

	xmpyu	 %fr4L,%fr31R,%fr5
	xmpyu	 %fr4R,%fr31R,%fr6
	xmpyu	 %fr8L,%fr31R,%fr9
	xmpyu	 %fr8R,%fr31R,%fr10

	fstds	 %fr5,-16(%r31)
	fstds	 %fr6,-8(%r31)
	fstds	 %fr9,0(%r31)
	fstds	 %fr10,8(%r31)

	ldws   -16(%r31),%r22
	ldws   -12(%r31),%r21
	ldws	-8(%r31),%r23
	ldws	-4(%r31),%r5
	ldws	 0(%r31),%r29
	ldws	 4(%r31),%r6
	ldws	 8(%r31),%r1
	ldws	12(%r31),%r7

	addc	 %r21,%r28,%r21
	addc	 %r5,%r22,%r5
	addc	 %r6,%r23,%r6
	addc	 %r7,%r29,%r7

	addib,<	 -4,%r24,L$end
	addc	 %r0,%r1,%r28			; propagate carry into %r28
; main loop ------------------------------------------------------------------
L$loop	fldds,ma 8(%r25),%fr4
	fldds,ma 8(%r25),%fr8

	ldws	 0(%r26),%r19
	xmpyu	 %fr4L,%fr31R,%fr5
	ldws	 4(%r26),%r20
	xmpyu	 %fr4R,%fr31R,%fr6
	ldws	 8(%r26),%r3
	xmpyu	 %fr8L,%fr31R,%fr9
	ldws	12(%r26),%r4
	xmpyu	 %fr8R,%fr31R,%fr10

	fstds	 %fr5,-16(%r31)
	add	 %r19,%r21,%r19
	fstds	 %fr6,-8(%r31)
	addc	 %r20,%r5,%r20
	fstds	 %fr9,0(%r31)
	addc	 %r3,%r6,%r3
	fstds	 %fr10,8(%r31)
	addc	 %r4,%r7,%r4

	ldws   -16(%r31),%r22
	ldws   -12(%r31),%r21
	ldws	-8(%r31),%r23
	ldws	-4(%r31),%r5
	ldws	 0(%r31),%r29
	ldws	 4(%r31),%r6
	ldws	 8(%r31),%r1
	ldws	12(%r31),%r7

	addc	 %r21,%r28,%r21
	stws,ma	 %r19,4(%r26)
	addc	 %r5,%r22,%r5
	stws,ma	 %r20,4(%r26)
	addc	 %r6,%r23,%r6
	stws,ma	 %r3,4(%r26)
	addc	 %r7,%r29,%r7
	stws,ma	 %r4,4(%r26)

	addib,>= -4,%r24,L$loop
	addc	 %r0,%r1,%r28			; propagate carry into %r28
; finish software pipeline ---------------------------------------------------
L$end	ldws	 0(%r26),%r19
	ldws	 4(%r26),%r20
	ldws	 8(%r26),%r3
	ldws	12(%r26),%r4

	add	 %r19,%r21,%r19
	stws,ma	 %r19,4(%r26)
	addc	 %r20,%r5,%r20
	stws,ma	 %r20,4(%r26)
	addc	 %r3,%r6,%r3
	stws,ma	 %r3,4(%r26)
	addc	 %r4,%r7,%r4
	stws,ma	 %r4,4(%r26)

; restore callee-saves registers ---------------------------------------------
	ldw	-96(%r30),%r3
	ldw	-92(%r30),%r4
	ldw	-88(%r30),%r5
	ldw	-84(%r30),%r6
	ldw	-80(%r30),%r7

L$few_limbs
	addib,=,n 4,%r24,L$ret
L$loop2	fldws,ma 4(%r25),%fr4
	ldws	 0(%r26),%r19
	xmpyu	 %fr4,%fr31R,%fr5
	fstds	 %fr5,-16(%r30)
	ldws	-16(%r30),%r22
	ldws	-12(%r30),%r21
	addc	 %r21,%r28,%r21
	addc	 %r0,%r22,%r28
	add	 %r19,%r21,%r19
	stws,ma	 %r19,4(%r26)
	addib,<> -1,%r24,L$loop2
	nop

L$ret	addc	 %r0,%r28,%r28
	bv	 0(%r2)
	ldo	 -128(%r30),%r30

	.exit
	.procend
