#ifndef SQUARING_BOUND
# define SQUARING_BOUND 8
#endif

#if KARA
# define KARA_EVERYWHERE 0     /* This option activates Karatsuba
				   multiplication for ZBNMultiplyFast
				   This is a little bit slower for most
				   of the applications */
#endif


#define ZBNNumDigits(n,nl) ((BigNumLength)BnnNumDigits(n, nl))


/* functions of bn */

#define ZBNIsZero(nn,nl) ((int)BnnIsZero(nn,nl))

#define ZBNMultiply(pp, pl, nn, nl, mm, ml) BnnMultiplyPlain(pp, (BigNumLength)(pl), nn, (BigNumLength)(nl), mm, (BigNumLength)(ml))
#define ZBNSmallSquare(x,xl,a,al) BnnSquarePlain(x,xl,a,al) /* Kept for compatibility */
#define ZBNLongSquare(x,xl,a,al) BnnSquareOpt(x,xl,a,al) /* Kept for compatibility */
#define ZBNSquare(x,xl,a,al) BnnSquare(x,xl,a,al)
#define ZBNMultiplyPlain(pp, pl, nn, nl, mm, ml) BnnMultiplyPlain(pp, (BigNumLength)(pl), nn, (BigNumLength)(nl), mm, (BigNumLength)(ml))

#define ZBNKaratsubaMultiplyCutoff(l) BnKaratsubaMultiplyCutoff(l)
#define ZBNKaratsubaSquareCutoff(l) BnKaratsubaSquareCutoff(l)
#define ZBNSizeBufKaraM(s) BnSizeBufKaraM(s)
#define ZBNSizeBufKaraS(s) BnSizeBufKaraS(s)

#define ZBNMultiplyKaratsubaBuffer(x,a,al,b,bl,buf) \
        BnMultiplyKaratsubaBuffer(x,a,al,b,bl,buf) 
#define ZBNSquareKaratsubaBuffer(x,a,al,buf) \
        BnSquareKaratsubaBuffer(x,a,al,buf)

#if KARA_EVERYWHERE
# define ZBNMultiplyFast(x,xl,a,al,b,bl) ZBNMultiplyKaratsuba(x,xl,a,al,b,bl)
# define ZBNSquareFast(x,xl,a,al) ZBNSquareKaratsuba(x,xl,a,al)
#else
# define ZBNMultiplyFast(x,xl,a,al,b,bl) ZBNMultiply(x,xl,a,al,b,bl)
# define ZBNSquareFast(x,xl,a,al) ZBNSquare(x,xl,a,al)
#endif

#define ZBNDivide(nn, nl, dd, dl) BnnDivide(nn, (BigNumLength)(nl), dd, (BigNumLength)(dl))
#define ZBNCompare(mm, ml, nn, nl) ((int)BnnCompare(mm, ml, nn, nl))

/* functions of KerN.c */
#define ZBNSetToZero(nn, nl) BnnSetToZero(nn, nl)
#define ZBNAssign(mm, nn, nl) BnnAssign(mm, nn, nl)
#define ZBNSetDigit(nn, d) BnnSetDigit(nn, (BigNumDigit)(d))
#define ZBNGetDigit(nn) BnnGetDigit(nn)
#define ZBNNumLeadingZeroBitsInDigit(d) BnnNumLeadingZeroBitsInDigit(d)

#define ZBNComplement(nn, nl) BnnComplement(nn, nl)
#define ZBNShiftLeft(mm, ml,nbits) BnnShiftLeft(mm, ml,nbits)
#define ZBNShiftRight(mm, ml,nbits) BnnShiftRight(mm, (BigNumLength)(ml),nbits)
#define ZBNAddCarry(nn, nl, carryin) ((BigNumDigit)BnnAddCarry(nn, nl, (BigNumCarry)(carryin)))
#define ZBNAdd(mm, ml, nn, nl, carryin) ((BigNumDigit)BnnAdd(mm, ml, nn, nl, (BigNumCarry)(carryin)))
#define ZBNSubtractBorrow(nn, nl, carryin) ((BigNumDigit)BnnSubtractBorrow(nn,nl, (BigNumCarry)(carryin)))
#define ZBNSubtract(mm, ml, nn, nl, carryin) ((BigNumDigit)BnnSubtract(mm, ml, nn, nl, (BigNumCarry)(carryin)))
#define ZBNMultiplyDigit(mm, ml, nn, nl, d) ((BigNumDigit)BnnMultiplyDigit(mm, ml, nn, nl, (BigNumCarry)(d)))

#define ZBNDigitGCD(a, b) BigNumDigitGCD((a), (b))
#define ZBNGcd(g, p_gl, n, nl, m, ml) (BnGcd(g, p_gl, n, nl, m, ml) ? (ZENSetError(ZEN_LIB_ZBZ, ZEN_GCDBINARY, ZEN_ALLOC), ZERR) : ZBN_HAS_INVERSE)

#define ZBNDivideDigit(qq, nn, nl, d) BnnDivideDigit(qq, nn, nl, d)

#define ZBNSetRandom(n,nl) BnnSetRandom(n,nl)



extern void ZBNModMultiplyKaratsubaBuffer ___((BigNum,BigNumLength,BigNum,BigNumLength,BigNum,BigNumLength,BigNum,BigNum,BigNumLength));
extern void ZBNModSquareKaratsubaBuffer ___((BigNum,BigNumLength,BigNum,BigNumLength,BigNum,BigNum,BigNumLength));

#ifndef ZBNMultiply
extern BigNumDigit ZBNMultiply ___((BigNum,BigNumLength,
				    BigNum,BigNumLength,
				    BigNum,BigNumLength));
#endif
#ifndef ZBNLongSquare
extern BigNumDigit ZBNLongSquare ___((BigNum,BigNumLength,
				      BigNum,BigNumLength));
#endif
extern BigNumDigit ZBNSmallSquare ___((BigNum,BigNumLength,
				       BigNum,BigNumLength));

extern int ZBNEea ___((BigNum,BigNumLength *,BigNum,BigNumLength*,BigNum,BigNumLength,BigNum,BigNumLength));

extern BigNumDigit ZBNMultDigit ___((BigNum,
				     BigNum,BigNumLength,
				     BigNumDigit));
extern void ZBNMult ___((BigNum,
			 BigNum,BigNumLength,
			 BigNum,BigNumLength));

extern void ZBNSqu ___((BigNum,
			BigNum,BigNumLength));

extern int ZBNCompareLazy ___((BigNum, BigNumLength, BigNum, BigNumLength));
