#define __CAST_BNLENGTH(l) (l)
#define __CAST_BNDIGIT(d) (d)
#define __CAST_BN(n) (n)



/* functions of bn */
#define ZBNMultiplyDigit(mm, ml, nn, nl, d) ((nl) ? ZBNAddCarry((mm)+(nl), (ml)-(nl), zmpn_addmul_1((mm), (nn), __CAST_BNLENGTH(nl), __CAST_BNDIGIT(d))) : (BigNumDigit)(0))
#define ZBNMultDigit(mm, nn, nl, d) ((nl) ? zmpn_mul_1(mm, nn, nl, d) : (void)0)

#define ZBNMultiply(pp, pl, nn, nl, mm, ml) _ZBNMultiplyPlain(pp, __CAST_BNLENGTH(pl), nn, __CAST_BNLENGTH(nl), mm, __CAST_BNLENGTH(ml))
#define ZBNMult(mm, nn, nl, pp, pl) ((pl) ? ((void)zmpn_mul(mm, nn, nl, pp, pl)) : (void)0)
#define ZBNMultiplyPlain(pp, pl, nn, nl, mm, ml) _ZBNMultiplyPlain(pp, __CAST_BNLENGTH(pl), nn, __CAST_BNLENGTH(nl), mm, __CAST_BNLENGTH(ml))
#define ZBNMultiplyFast(pp, pl, nn, nl, mm, ml) _ZBNMultiplyPlain(pp, __CAST_BNLENGTH(pl), nn, __CAST_BNLENGTH(nl), mm, __CAST_BNLENGTH(ml))
#define ZBNMultiplyKaratsubaBuffer(x,a,al,b,bl,buf) (((al) & (bl)) ? zmpn_mul(x,a,__CAST_BNLENGTH(al),b,__CAST_BNLENGTH(bl)) : 0)
#define ZBNKaratsubaMultiplyCutoff(l) 0
#define ZBNSizeBufKaraM(l) 1

#define ZBNSquare(x,xl,a,al) _ZBNSquarePlain(x,__CAST_BNLENGTH(xl),a,__CAST_BNLENGTH(al))
#define ZBNSqu(mm, nn, nl) ((nl) ? ((void)zmpn_mul_n(mm, nn, nn, nl)) : (void)0)
#define ZBNSmallSquare(x,xl,a,al) _ZBNSquarePlain(x,__CAST_BNLENGTH(xl),a,__CAST_BNLENGTH(al)) /* Kept for compatibility */
#define ZBNLongSquare(x,xl,a,al) _ZBNSquarePlain(x,__CAST_BNLENGTH(xl),a,__CAST_BNLENGTH(al)) /* Kept for compatibility */
#define ZBNSquareFast(x,xl,a,al) _ZBNSquarePlain(x,__CAST_BNLENGTH(xl),a,__CAST_BNLENGTH(al))
#define ZBNSquareKaratsubaBuffer(x,a,al,buf) ((al) ? (zmpn_mul_n(x,a,a,__CAST_BNLENGTH(al)), 0) : 0)
#define ZBNKaratsubaSquareCutoff(l) 0
#define ZBNSizeBufKaraS(l) 1

#define ZBNDivideDigit(qq, nn, nl, d) ((BigNumDigit)(zmpn_divrem_1(qq, 0, nn, __CAST_BNLENGTH(nl), __CAST_BNDIGIT(d))))


/* functions of KerN.c */
#define ZBNSetToZero(nn, nl) MPN_ZERO(nn, __CAST_BNLENGTH(nl))

#define ZBNSetDigit(nn, d) ((void)(ZBNDigit((nn), 0) = __CAST_BNDIGIT(d)))
#define ZBNGetDigit(nn) ZBNDigit((nn), 0)


#define ZBNShiftLeft(mm, ml,nbits) ((nbits) ? (BigNumDigit)(zmpn_lshift(mm, mm, __CAST_BNLENGTH(ml), nbits)) : (BigNumDigit)(0))
#define ZBNShiftRight(mm, ml,nbits) ((nbits) ? (BigNumDigit)(zmpn_rshift(mm, mm, __CAST_BNLENGTH(ml), nbits)) : (BigNumDigit)(0))

#define ZBNAddCarry(nn, nl, carryin) \
    ((nl) ? (BigNumDigit)(zmpn_add_1(nn, nn, __CAST_BNLENGTH(nl), __CAST_BNDIGIT(carryin))) : carryin)
#define ZBNAdd(mm, ml, nn, nl, carryin) \
((nl) ? \
  ((ml) <= (nl) ? \
    (BigNumDigit)(zmpn_add_n(mm, mm, nn, __CAST_BNLENGTH(ml))+zmpn_add_1(mm, mm, __CAST_BNLENGTH(ml), carryin)) \
  : \
    (BigNumDigit)(zmpn_add_1((mm)+(nl), (mm)+(nl), __CAST_BNLENGTH((ml)-(nl)), zmpn_add_n(mm, mm, nn, __CAST_BNLENGTH(nl))+zmpn_add_1(mm, mm, __CAST_BNLENGTH(nl), carryin)))) \
: ZBNAddCarry(mm, ml, carryin))


#define ZBNSubtractBorrow(nn, nl, carryin) \
     ((nl) ? (BigNumDigit)(zmpn_sub_1(nn, nn, __CAST_BNLENGTH(nl), (BigNumDigit)(1-(carryin)))) : carryin)
#define ZBNSubtract(mm, ml, nn, nl, carryin) \
((nl) ? \
  ((ml) <= (nl) ? \
    ((BigNumDigit)(1)-(BigNumDigit)(zmpn_sub_n(mm, mm, nn, __CAST_BNLENGTH(ml))+zmpn_sub_1(mm, mm, __CAST_BNLENGTH(ml), (BigNumDigit)(1-(carryin))))) \
  : \
    ((BigNumDigit)(1)-(BigNumDigit)(zmpn_sub_1((mm)+(nl), (mm)+(nl), __CAST_BNLENGTH((ml)-(nl)), zmpn_sub_n(mm, mm, nn, __CAST_BNLENGTH(nl))+zmpn_sub_1(mm, mm, __CAST_BNLENGTH(nl), (BigNumDigit)(1-(carryin))))))) \
: ZBNSubtractBorrow(mm,ml,carryin))


#if defined(hp) || defined(i486icc) || defined(i486) || defined(i486linux) || defined(linux) || defined(cygnus)
# define USE_RAND 1
#else
# define USE_RAND 0
#endif

#if USE_RAND
# define zbnsrandom(a) srand((long)a)
#else
# define zbnsrandom(a) srand48((long)a)
#endif

#if USE_RAND
# if SIZE_BLOC == 64
# define zbnrandom()\
  (BigNumDigit)((((BigNumDigit)rand() << 17) ^ ((BigNumDigit)rand() << 2) ^ (BigNumDigit)rand()) ^ \
  ((BigNumDigit)((((BigNumDigit)rand() << 17) ^ ((BigNumDigit)rand() << 2) ^ (BigNumDigit)rand())) << 32))
#else
# define zbnrandom()\
  (BigNumDigit)(((BigNumDigit)rand() << 17) ^ ((BigNumDigit)rand() << 2) ^ (BigNumDigit)rand())
#endif
#else
# if SIZE_BLOC == 64
#  define zbnrandom() (BigNumDigit)(((BigNumDigit)mrand48() << 32) ^ (BigNumDigit)mrand48())
# else
#  define zbnrandom() (BigNumDigit)mrand48()
# endif
#endif

extern BigNumDigit ZBNDigitGCD ___((BigNumDigit,BigNumDigit));
extern int ZBNGcd ___((BigNum, BigNumLength *,
		       BigNum, BigNumLength,
		       BigNum, BigNumLength));
extern int ZBNEea ___((BigNum,BigNumLength *,BigNum,BigNumLength*,BigNum,BigNumLength,BigNum,BigNumLength));

extern BigNumLength ZBNNumDigits ___((BigNum, BigNumLength));
extern int ZBNIsZero ___((BigNum, BigNumLength));
extern int ZBNCompare ___((BigNum, BigNumLength, BigNum, BigNumLength));
extern int ZBNCompareLazy ___((BigNum, BigNumLength, BigNum, BigNumLength));
extern void ZBNComplement ___((BigNum, BigNumLength));
extern void ZBNAssign ___((BigNum, BigNum, BigNumLength));

extern void ZBNSetRandom ___((BigNum, BigNumLength));
extern BigNumDigit _ZBNMultiplyPlain ___((BigNum, BigNumLength, BigNum, BigNumLength, BigNum, BigNumLength));
extern BigNumDigit _ZBNSquarePlain ___((BigNum, BigNumLength, BigNum, BigNumLength));
extern unsigned int ZBNNumLeadingZeroBitsInDigit ___((BigNumDigit));
extern void ZBNDivide ___((BigNum, BigNumLength, BigNum, BigNumLength));
