/* \TEX{
   \Subsection{Element tests}
   
   Three functions are provided to do tests: |_Ze2EltAreEqual| to test if two
   |ZENElt| are equal, |_Ze2EltIsZero| to test if a |ZENelt| is equal to
   zero, |_Ze2EltIsOne| to test if a |ZENelt| is equal to one.
   }
   */
#include <stdio.h>
#include "ze2.h"

/* \TEX[
   \title{Equal.}
   \input{Two |ZENElt| |a| and |b| of a finite ring |R|.}
   \output{|a| == |b|.}
   }
   */
int _Ze2EltAreEqual(a,b,R)
     ZENElt a, b;
     ZENRing R;
{
  return(Ze2EltAreEqual(a,b,R));
}

/* \TEX[
   \title{Is zero.}
   \input{A |ZENElt| |a| of a finite ring |R|.}
   \output{|a| == 0.}
   }
   */
int _Ze2EltIsZero(a, R)
     ZENElt a;
     ZENRing R;
{
  return(Ze2EltIsZero(a, R));
}

/* \TEX[
   \title{Is one.}
   \input{ |ZENElt| |a| of a finite ring |R|.}
   \output{|a| == 1.}
   }
   */
int _Ze2EltIsOne(a, R)
     ZENElt a;
     ZENRing R;
{
  return(Ze2EltIsOne(a, R));
}
