/* \TEX{
   \Subsection{Element inversion}
   
   |_ZelogEltInverse| computes the inverse of a |ZENElt|.
   }
   */
#include <stdio.h>
#include "zelog.h"

/* \TEX{
   \title{Inverse.}
   \input{A pointer |p_c| on a |ZENElt| and two |ZENElt| |a| and |b| of a
   finite ring |Rg|.}
   \output{|ZENERR| if |a|=0, |ZEN_HAS_INVERSE| otherwise.}
   \side{$|*p_c| = 1/a$ if |a| has an inverse, ZENRingFact(Rg) is NOT
   filled with a factor of the modulo otherwise.} 
   }
   */
int _ZelogEltInverse(p_c, a, Rg)
     ZENElt *p_c, a;
     ZENRing Rg;
{
  return(ZelogEltInverse(*p_c, a, Rg));
}
