/* \TEX{
   \Subsection{Element tests}
   
   Three functions are provided to do tests: |_ZelogEltAreEqual| to test if two
   |ZENElt| are equal, |_ZelogEltIsZero| to test if a |ZENelt| is equal to
   zero, |_ZelogEltIsOne| to test if a |ZENelt| is equal to one.
   }
   */
#include <stdio.h>
#include "zelog.h"

/* \TEX{
   \title{Equal.}
   \input{Two |ZENElt| |a| and |b| of a finite ring |Rg|.}
   \output{|a| == |b|.}
   }
   */
int _ZelogEltAreEqual(a, b, Rg)
     ZENElt a, b;
     ZENRing Rg;
{
  return(ZelogEltAreEqual(a, b, Rg));
}

/* \TEX{
   \title{Is zero.}
   \input{A |ZENElt| |a| of a finite ring |Rg|.}
   \output{|a| == 0.}
   }
   */
int _ZelogEltIsZero(a, Rg)
     ZENElt a;
     ZENRing Rg;
{
  return(ZelogEltIsZero(a, Rg));
}

/* \TEX{
   \title{Is one.}
   \input{ |ZENElt| |a| of a finite ring |Rg|.}
   \output{|a| == 1.}
   }
   */
int _ZelogEltIsOne(a, Rg)
     ZENElt a;
     ZENRing Rg;
{
  return(ZelogEltIsOne(a, Rg));
}
