/* \TEX{
   \Subsection{Element additions}
   
   |_ZetabEltAdd| enable us to add a |ZENElt| to another.
   }
   */
#include <stdio.h>
#include "zetab.h"

/* \TEX{
   \title{Addition.}
   \input{A pointer |p_c| on a |ZENElt| and a |ZENElt| |a| of a finite ring
   |Rg|.}
   \side{|*p_c| += |a|.}
   }
   */
void _ZetabEltAdd(p_c, a, Rg)
     ZENElt *p_c, a;
     ZENRing Rg;
{
  ZetabEltAdd(*p_c, a, Rg);
}

/* \TEX{
   \title{Negation.}
   \input{A pointer |p_c| on a |ZENElt| and a |ZENElt| |a| of a finite ring
   |Rg|.}
   \side{|*p_c| = -|a|.}
   }
   */
void _ZetabEltNegate(p_c, a, Rg)
     ZENElt *p_c, a;
     ZENRing Rg;
{

  ZetabEltNegate(*p_c, a, Rg);
}


/* \TEX{
   \title{Subtract.}
   \input{A pointer |p_c| on a |ZENElt| and a |ZENElt| |a| of a finite ring
   |Rg|.}
   \side{|*p_c| -= |a|.}
   }
   */
void _ZetabEltSubtract(p_c, a, Rg)
     ZENElt *p_c, a;
     ZENRing Rg;
{
  ZetabEltSubtract(*p_c, a, Rg);
}
