/*
   \TEX{
   \Subsection{Element multiplication}
   
   Two functions are provided to do multiplications: |_ZetabEltSquare| to square a
   |ZENElt| and |_ZetabEltMultily| to compute the multiplication of two |ZENElt|.
   }
   */
#include <stdio.h>
#include "zetab.h"

/* \TEX{
   \title{Squaring.}
   \input{A pointer |p_c| on a |ZENElt| and a |ZENElt| |a| of a finite ring
   |R|.}
   \side{$|*p_c| = a^2$.}
   }
   */
void _ZetabEltSquare(p_c, a, Rg)
     ZENElt *p_c, a;
     ZENRing Rg;
{
  ZetabEltSquare(*p_c,a,Rg);
}

/* \TEX{
   \title{Multiplication.}
   \input{A pointer |p_c| on a |ZENElt| and two |ZENElt| |a| and |b| of a
   finite ring |Rg|.}
   \side{$|*p_c| = a\times b$.}
   }
   */
void _ZetabEltMultiply(p_c, a, b, Rg)
     ZENElt *p_c, a, b;
     ZENRing Rg;
{
  ZetabEltMultiply(*p_c,a,b,Rg);
}



