/* \TEX{
   \Subsection{Element tests}
   
   Three functions are provided to do tests: |_ZetabEltAreEqual| to test if two
   |ZENElt| are equal, |_ZetabEltIsZero| to test if a |ZENelt| is equal to
   zero, |_ZetabEltIsOne| to test if a |ZENelt| is equal to one.
   }
   */
#include <stdio.h>
#include "zetab.h"

/* \TEX{
   \title{Equal.}
   \input{Two |ZENElt| |a| and |b| of a finite ring |Rg|.}
   \output{|a| == |b|.}
   }
   */
int _ZetabEltAreEqual(a, b, Rg)
     ZENElt a, b;
     ZENRing Rg;
{
  return(ZetabEltAreEqual(a, b, Rg));
}

/* \TEX{
   \title{Is zero.}
   \input{A |ZENElt| |a| of a finite ring |Rg|.}
   \output{|a| == 0.}
   }
   */
int _ZetabEltIsZero(a, Rg)
     ZENElt a;
     ZENRing Rg;
{
  return(ZetabEltIsZero(a, Rg));
}

/* \TEX{
   \title{Is one.}
   \input{ |ZENElt| |a| of a finite ring |Rg|.}
   \output{|a| == 1.}
   }
   */
int _ZetabEltIsOne(a, Rg)
     ZENElt a;
     ZENRing Rg;
{
  return(ZetabEltIsOne(a, Rg));
}
