/* \TEX{
   \Subsection{Matricial permutations}

   These functions are general ones. They are directly written with |ZENElt| functions and are used in general cases. See the other directories for specially written functions.
   }
   */
#include <stdio.h>
#include "zetab.h"


/*
   \TEX{
   \title{Permute two |Bn|s}
   \input{A |ZENMat| |A|, two indexes and a finite ring |R|.}
   \output{|ZENERR| if an error occured, 0 otherwise}
   \side{The specified |Bns| of |A| are exchanged}
   \note{Except for advanced user, |PermuteRow| and |PermuteCol| functions should be preferred}
   }
   
   */
   
int _ZetabMatPermuteBn(A,l1,l2,R)
     ZENMat A;
     Dim l1,l2;
     ZENRing R;
{int c;
 ZENElt S;
 
 ZENTest(ZetabMatIsPermutation(A,R),
	 ZEN_ISPERM,ZEN_MATPERMUTEBNS,ZEN_LIB_ZETAB, ZERR);
 ZENTest((l1<0)||(l2<0)||(l1>=ZetabMatNbBn(A,R))||(l2>=ZetabMatNbBn(A,R)),
	 ZEN_MAT_DIM0,ZEN_MATPERMUTEBNS,ZEN_LIB_ZETAB, ZERR);

 for(c=ZetabMatNbDigit(A,R)-1;c>=0;c--)
   {
     ZetabAnyEltAssign(ZetabElt2Int(S,R),ZetabMatBloc(A,l1,c,R),R);
     ZetabAnyEltAssign(ZetabMatBloc(A,l1,c,R),ZetabMatBloc(A,l2,c,R),R);
     ZetabAnyEltAssign(ZetabMatBloc(A,l2,c,R),ZetabElt2Int(S,R),R);
   }
 return(0);
}

/*
   \TEX{
   \title{Permute two |digit|s}
   \input{A |ZENMat| |A|, two indexes and a finite ring |R|.}
   \output{|ZENERR| if an error occured, 0 otherwise}
   \side{The specified |digits| of |A| are exchanged}
   \note{Except for advanced user, |PermuteRow| and |PermuteCol| functions should be preferred}
   }   
   */
   

int _ZetabMatPermuteDigit(A,l1,l2,R)
     ZENMat A;
     Dim l1,l2;
     ZENRing R;
{int c;
 ZENElt S;
 
 ZENTest(ZetabMatIsPermutation(A,R),
	 ZEN_ISPERM,ZEN_MATPERMUTEDG,ZEN_LIB_ZETAB, ZERR);
 ZENTest((l1<0)||(l2<0)||(l1>=ZetabMatNbDigit(A,R))||(l2>=ZetabMatNbDigit(A,R)),
	 ZEN_MAT_DIM0,ZEN_MATPERMUTEDG,ZEN_LIB_ZETAB, ZERR);

 for(c=ZetabMatNbBn(A,R)-1;c>=0;c--)
   {
     ZetabAnyEltAssign(ZetabElt2Int(S,R),ZetabMatBloc(A,c,l1,R),R);
     ZetabAnyEltAssign(ZetabMatBloc(A,c,l1,R),ZetabMatBloc(A,c,l2,R),R);
     ZetabAnyEltAssign(ZetabMatBloc(A,c,l2,R),ZetabElt2Int(S,R),R);
   }
 return(0);
}

