/* \TEX{
   \Subsection{Element additions}
   
   |_ZextEltAdd| enable us to add a |ZENElt| to another.
   }
   */
#include <stdio.h>
#include "zext.h"

/* \TEX{
   \title{Addition.}
   \input{A pointer |p_c| on a |ZENElt| and a |ZENElt| |a| of a finite ring
   |Rg|.}
   \side{|*p_c| += a.}
   }
   */
void _ZextEltAdd(p_c, a, Rg)
     ZENElt *p_c, a;
     ZENRing Rg;
{
  ZextEltAdd(*p_c, a, Rg);
}

/* \TEX{
   \title{Negation.}
   \input{A pointer |p_c| on a |ZENElt| and a |ZENElt| |a| of a finite ring
   |Rg|.}
   \side{|*p_c| = -|a|.}
   }
   */
void _ZextEltNegate(p_c, a, Rg)
     ZENElt *p_c, a;
     ZENRing Rg;
{
  ZextEltNegate(*p_c, a, Rg);
}


/* \TEX{
   \title{Subtract.}
   \input{A pointer |p_c| on a |ZENElt| and a |ZENElt| |a| of a finite ring
   |Rg|.}
   \side{|*p_c| += a.}
   }
   */
void _ZextEltSubtract(p_c, a, Rg)
     ZENElt *p_c, a;
     ZENRing Rg;
{
  ZextEltSubtract(*p_c, a, Rg);
}
