/* \TEX{
   \Subsection{Element tests}
   
   Three functions are provided to do tests: |_ZextEltAreEqual| to test if two
   |ZENElt| are equal, |_ZextEltIsZero| to test if a |ZENelt| is equal to
   zero, |_ZextEltIsOne| to test if a |ZENelt| is equal to one.
   }
   */
#include <stdio.h>
#include "zext.h"

/* \TEX{
   \title{Equal.}
   \input{Two |ZENElt| |a| and |b| of a finite ring |Rg|.}
   \output{|a| == |b|.}
   }
   */
int _ZextEltAreEqual(a, b, Rg)
     ZENElt a, b;
     ZENRing Rg;
{
  return(ZextEltAreEqual(a, b, Rg));
}

/* \TEX{
   \title{Is zero.}
   \input{A |ZENElt| |a| of a finite ring |Rg|.}
   \output{|a| == 0.}
   }
   */
int _ZextEltIsZero(a, Rg)
     ZENElt a;
     ZENRing Rg;
{
  return(ZextEltIsZero(a, Rg));
}

/* \TEX{
   \title{Is one.}
   \input{ |ZENElt| |a| of a finite ring |Rg|.}
   \output{|a| == 1.}
   }
   */
int _ZextEltIsOne(a, Rg)
     ZENElt a;
     ZENRing Rg;
{
  return(ZextEltIsOne(a, Rg));
}


